unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, DBCtrls, EkRtf, Db, DBTables, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    BioTable: TTable;
    EkRTF1: TEkRTF;
    DBImage1: TDBImage;
    DBNavigator1: TDBNavigator;
    Label1: TLabel;
    GetReport: TButton;
    Source: TButton;
    DBText1: TDBText;
    DBText2: TDBText;
    Label2: TLabel;
    Label3: TLabel;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    Label6: TLabel;
    Label7: TLabel;
    EScaleX: TEdit;
    EScaleY: TEdit;
    UDScaleX: TUpDown;
    UDScaleY: TUpDown;
    CloseBtn: TButton;
    Labelx: TLabel;
    Labely: TLabel;
    BrBox: TComboBox;
    ClDlg: TColorDialog;
    BrColorBtn: TButton;
    Shape1: TShape;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    BrWidthBox: TComboBox;
    StaticText3: TStaticText;
    procedure GetReportClick(Sender: TObject);
    procedure SourceClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure UDScaleXClick(Sender: TObject; Button: TUDBtnType);
    procedure UDScaleYClick(Sender: TObject; Button: TUDBtnType);
    procedure EkRTF1ImageFormat(FormatIndex: Integer;
      var ImageFormat: TEkImageFormat);
    procedure DataSource1DataChange(Sender: TObject; Field: TField);
    procedure FormShow(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure BrColorBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure UpdateSizeControls;
  end;

var
  Form1: TForm1;
  MyFormat:TEkImageFormat;

implementation
uses ShellApi;
{$R *.DFM}

function RunFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..250] of Char;
begin
 Result := ShellExecute(Application.MainForm.Handle, nil,
   StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
   StrPCopy(zDir, DefaultDir), ShowCmd);
end;


function getnumber:string;
var Hour,Min,Sec,MSec:Word;
  SHour,SMin,SSec,SMSec:string;
begin
DecodeTime(Now(), Hour, Min, Sec, MSec);
SHour:=inttostr(Hour);
SMin:=inttostr(Min); sSec:=inttostr(Sec); sMsec:=inttostr(MSec);
if Hour<10 then SHour:='0'+SHour;
if Min<10 then SMin:='0'+SMin;
if Sec<10 then Ssec:='0'+Ssec;
result:=SHour+smin+ssec;
end;


procedure TForm1.GetReportClick(Sender: TObject);
begin
  if FileExists(ExtractFilePath(Paramstr(0))+'\graphic.rtf') then
    begin
    EkRtf1.OutFile:=ExtractFilePath(Paramstr(0))+'\gr'+getnumber+'.rtf';
    EkRtf1.ExecuteOpen([BioTable],SW_SHOW);
    end else showmessage('Input file graphic.rtf not found!. Place your compiled exe file into project source directory.');
end;

procedure TForm1.SourceClick(Sender: TObject);
begin
if FileExists(ExtractFilePath(Paramstr(0))+'\graphic.doc') then
   begin
   RunFile('graphic.doc','','',SW_SHOW);
   end else showmessage('File graphic.doc not found!. Place your compiled exe file into project source directory.');
end;

procedure TForm1.UpdateSizeControls;
begin
  EScaleX.Text:=inttostr(MyFormat.ScaleX);
  EScaleY.Text:=inttostr(MyFormat.ScaleY);
end;



procedure TForm1.CloseBtnClick(Sender: TObject);
begin
Close;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
MyFormat.Free;
end;


procedure TForm1.FormCreate(Sender: TObject);
var wd:double;
begin
  MyFormat:=TEkImageFormat.create(DBImage1.Picture.width,DBImage1.Picture.height);
  BrBox.ItemIndex:=0;
  UpdateSizeControls;
  wd:=0.5;
  while wd<=3 do
  begin
    brWidthBox.Items.Add(FloatToStr(wd));
    wd:=wd+0.5;
  end;
  brWidthBox.ItemIndex:=0;
end;

procedure TForm1.UDScaleXClick(Sender: TObject; Button: TUDBtnType);
begin
MyFormat.Proportional:=CheckBox1.checked;
MyFormat.ScaleX:=UDScaleX.Position;
UpdateSizeControls;
end;

procedure TForm1.UDScaleYClick(Sender: TObject; Button: TUDBtnType);
begin
MyFormat.Proportional:=CheckBox1.checked;
MyFormat.ScaleY:=UDScaleY.Position;
UpdateSizeControls;
end;

procedure TForm1.EkRTF1ImageFormat(FormatIndex: Integer;
  var ImageFormat: TEkImageFormat);
begin
MyFormat.SetBorderType(BrBox.itemindex,StrToFloat(BrWidthBox.Text),0);
ImageFormat:=MyFormat;
{
  It is recommended if you will use SizeXmm and
  SizeYmm properties for your images.
  For example: ImageFormat.SizeXmm=70 //70 millimeters

  You can also set all properties separately.
  Proportional property must be set first if ScaleX differs ScaleY

ImageFormat.Proportional:=MyFormat.Proportional;
ImageFormat.ScaleX:=MyFormat.ScaleX;
ImageFormat.ScaleY:=MyFormat.ScaleY;}
end;

procedure TForm1.DataSource1DataChange(Sender: TObject; Field: TField);
begin
If Form1.Visible then begin
                      Labelx.Caption:='Image width='+inttostr(dbimage1.picture.width);
                      Labely.Caption:='Image height='+inttostr(dbimage1.picture.height);
                      end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Labelx.Caption:='Image width='+inttostr(dbimage1.picture.width);
  Labely.Caption:='Image height='+inttostr(dbimage1.picture.height);
  Shape1.Brush.Color:=ClDlg.color;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
if CheckBox1.checked then MyFormat.Proportional:=true else MyFormat.Proportional:=false;
end;

procedure TForm1.BrColorBtnClick(Sender: TObject);
begin
if ClDlg.Execute then
    begin
     Shape1.Brush.Color:=ClDlg.color;
     EkRtf1.ColorTable[0].color:=ClDlg.color;
     //We will use this color for border;
    end;
end;

end.

